/*
 * This OS/2 port was hacked by Harald Kipp from the
 *
 *      Network News Transfer Protocol server
 *
 *      Phil Lapsley
 *      University of California, Berkeley
 *      Stan Barber
 *      Baylor College of Medicine
 *
 * Bug reports related to THIS modified version should be sent to
 *
 *  harald@os2point.ping.de
 *  harald@haport.sesam.com
 *  Fido: 2:2448/434
 *
 * You may freely copy or redistribute this software. However,
 * this may not apply to any part of changi, if otherwise noted.
 */

extern char *version;


#ifdef NEWDBM
#include <fcntl.h>
#include "dbm.h"
#endif


/*----------------------------------------------------------------------*/
VOID _cdecl ClientThread(int *ps);

int parsit(char *line, char ***array);

int get_distlist(char ***array, char *list);


int ngmatch(int (*func)(char *, char *), int dflt, char **ngspec,
            int ngspeccount, char **matchlist, int matchcount);

int s1strneql(char *s1, char *s2);


int get_nglist(char ***array, char *list);


int check_ngperm(FILE *fp);
void spew(int s, FILE *fp, int how);
int findart(char *artname, long art_array[], int num_arts);

int scan_dir(long low_msg, long high_msg, long art_array[]);

int restreql(char *w, char *s);

int space(int min_free);



/*----------------------------------------------------------------------*/
/*  Functions performing main nntp commands                             */
/*                                                                      */
/*----------------------------------------------------------------------*/

typedef struct _NEWSCLIENT {
    int  s;                  /* socket */
    int  ingroup;
    int  canpost;
    int  canread;
    int  canxfer;
    char *group_name;
    int  num_arts;
    long art_array[MAX_ARTICLES];
    int  art_ptr;
    FILE *art_fp;
    long art_num;
    char art_id[MAXBUFLEN];
#ifdef NEWDBM
    DBM  *db;
#endif
    char **nglist;
} NEWSCLIENT, *PNEWSCLIENT;

extern void ahbs(PNEWSCLIENT, int, char **);
extern void dodate(PNEWSCLIENT, int, char **);
extern void group(PNEWSCLIENT, int, char **);
extern void help(PNEWSCLIENT, int, char **);
extern void ihave(PNEWSCLIENT, int, char **);
extern void ignore(PNEWSCLIENT, int, char **);
extern void list(PNEWSCLIENT, int, char **);
extern void newgroups(PNEWSCLIENT, int, char **);
extern void newnews(PNEWSCLIENT, int, char **);
extern void nextlast(PNEWSCLIENT, int, char **);
extern void post(PNEWSCLIENT, int, char **);
extern void slave(PNEWSCLIENT, int, char **);
extern void listgroup(PNEWSCLIENT, int, char **);
extern void xhdr(PNEWSCLIENT, int, char **);
extern void doxover(PNEWSCLIENT, int, char **);
extern void xthread(PNEWSCLIENT, int, char **);
extern void xindex(PNEWSCLIENT, int, char **);

extern char *gethistent(PNEWSCLIENT pnc, char *msg_id, char *path);
extern FILE *openartbyid(PNEWSCLIENT pnc, char *msg_id);


#if 0
extern int _cdecl so_printf(int s, char *format, ...);
extern int so_puts(int s, char *line);
extern int recv_line(int s, char *pline);
#endif


int spawn(int s, char *cmnd, int cont_code, int err_code);


FILE *open_valid_art(PNEWSCLIENT pnc, char *artname, char *id);


extern int initexit(void);
