/*
 * This OS/2 port was hacked by Harald Kipp from the
 *
 *      Network News Transfer Protocol server
 *
 *      Phil Lapsley
 *      University of California, Berkeley
 *      Stan Barber
 *      Baylor College of Medicine
 *
 * Bug reports related to THIS modified version should be sent to
 *
 *  harald@os2point.ping.de
 *  harald@haport.sesam.com
 *  Fido: 2:2448/434
 *
 */

#define OS2
#define INCL_DOSFILEMGR
#define INCL_DOSDATETIME
#include <os2.h>

#include <types.h>
#include <netinet\in.h>
#include <sys\socket.h>
#include <netlib.h>

#undef min
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <string.h>

#include <lprintf.h>


#include "config.h"
#include "globals.h"
#include "nntp.h"
#include "changi.h"

#if 0
/************************************************************************/
/*                                                                      */
/************************************************************************/
int so_puts(int s, char *line)
{
    int rc;

    rc = send(s, line, strlen(line), 0);
    if(rc == -1)
        lprintf("send(): Error %d", errno);
    else if(dolog(LOG_SEND)) {
        char *cp = strchr(line, '\r');
        if(cp)
            *cp = '\0';
        if(*line)
            lprintf("<'%s'", line);
        if(cp)
            *cp = '\r';
    }


    return (rc);
}


/************************************************************************/
/*                                                                      */
/************************************************************************/
int _cdecl so_printf(int s, char *format,...)
{
    int rc;
    char achBuf[512];
    va_list marker;

    va_start(marker, format);
    vsprintf(achBuf, format, marker);
    rc = so_puts(s, achBuf);
    va_end(marker);

    return (rc);
}
#endif

/************************************************************************/
/*                                                                      */
/************************************************************************/
static int longcmp(long *x, long *y)
{
    if(*x > *y)
        return(1);
    else if(*x < *y)
        return(-1);
    return(0);
}

/************************************************************************/
/*                                                                      */
/************************************************************************/
int scan_dir(long low_msg, long high_msg, long art_array[])
{
    long artnum;
    HDIR hdir = HDIR_CREATE;
    int sOff = sizeof(FILEFINDBUF) - CCHMAXPATHCOMP + 1;
    PFILEFINDBUF paffb = malloc(12288);
    PFILEFINDBUF pffb;
    int cffb = 255;
    int rc;
    int i;
    int num_arts = 0;

    if((rc = DosFindFirst2("*", &hdir, 0, paffb, 12288, &cffb, 1, 0L)) == 0) {
        while (!rc && cffb) {
            pffb = paffb;
            for(i = 0; i < cffb; i++) {
                artnum = atol(pffb->achName);
                if (artnum && artnum >= low_msg && artnum <= high_msg)
                    art_array[num_arts++] = artnum;
                pffb = (PFILEFINDBUF)((char *)pffb + sOff + pffb->cchName);
            }
            cffb = 255;
            rc = DosFindNext(hdir, paffb, 12288, &cffb);
        }
        DosFindClose(hdir);
        qsort(art_array, num_arts, sizeof(long), longcmp);
    }
    free(paffb);
    return (num_arts);
}
#if 0
/************************************************************************/
/*                                                                      */
/************************************************************************/
char *fine_dir(char *path)
{
    if(path && *path) {
        char *cp = path;
        while(*cp) {
            if(*cp == '\\')
                *cp = '/';
            cp++;
        }
        if(*--cp == '/')
            *cp = '\0';
        return(path);
    }
    return(NULL);
}
#endif
